function n = getResponsiveCount(data,base_start,sig,odor_start,odor_dur,fps,fraction)

numLoc = size(data,1);
n = zeros(numLoc,1);

for i = 1:numLoc
    %get the significant threshold
    locust = data(i,:);
    baseline = locust(base_start*fps+1:(base_start+2)*fps);
    baseline_mean = mean(baseline);
    baseline_std = std(baseline);
    threshold = baseline_mean+sig*baseline_std;
    
    o = locust(odor_start*fps+1:(odor_start+odor_dur)*fps);
    frames_fraction = fraction*fps*odor_dur;
    
    if sum(o>threshold) >=frames_fraction
       n(i) = 1;
    end
    
end

n = sum(n);