%%%%%%%%%%%%%
% Code to generate behavior plots shown in Supplementary Figure 11 for
% "Invariant Odor Recognition with ON-OFF Neural Ensembles"
% Authors:Srinath Nizampatnam, Lijun Zhang, Rishabh Chandak, James Li, Barani Raman
% Washington University in St. Louis
% Code written by: Rishabh Chandak
% Version current as of: December 10, 2021
% doi: 10.1073/pnas.2023340119
%%%%%%%%%%%%%
%% Supplementary Figure 11G 11H plots

odors = {'bza','hex'};
nums = {'1','2','3','4','5'};
times = [3,12,3,2,3,3,14,14,2,8]-2;
times = times*30+1;
i=1;
compiled = [];
close all
time = 1/30:1/30:269/30;
for o = 1:2
    for n = 1:5
        fname = strcat(odors{o},nums{n},'.csv');
        data = readmatrix(fname);
        d = filtfilt(ones(1,3),3,data);
        figure(o)
        hold on
        d = d(times(i):times(i)+268);
        d = d - mean(d(1:30));
        d = max(0,d);
        plot(time,d,'k')
        compiled = [compiled,d];
        ylim([0 50])
        xticks([2 6])
        i= i+1;
    end
end

%plot the means
figure(1)
plot(time,mean(compiled(:,1:5)'))
r1 = rectangle('Position',[2,0,4,5],'FaceColor','r');
uistack(r1,'bottom')
ylim([0 5])
xticklabels([])
xticks([])
figure(2)
plot(time,mean(compiled(:,6:10)'))
r1 = rectangle('Position',[2,0,4,50],'FaceColor','b');
uistack(r1,'bottom')
xticklabels([])
xticks([])