%%%%%%%%%%%%%
% Code to angular analysis shown in supp. fig. 7
% "Invariant Odor Recognition with ON-OFF Neural Ensembles"
% Authors:Srinath Nizampatnam, Lijun Zhang, Rishabh Chandak, James Li, Barani Raman
% Washington University in St. Louis
% Code written by: Barani Raman,Lijun Zhang
% Version current as of: December 10, 2021
% doi: 10.1073/pnas.2023340119
close all
clear
clc
d = [];
dim = 89;
thresh = 2;
for ii = 1: 1000
a = rand(dim,1)+rand(dim,1).*-1;
a = ceil(a.*10);
b = [a>thresh]+[a<-thresh].*-1;
d = [d, (acosd(a'*b/(norm(a)*norm(b))))];
end
figure(1);plot(d)
d2 = [];
for ii = 1: 1000
a = rand(dim,1)+rand(dim,1).*-1;
b = rand(dim,1)+rand(dim,1).*-1;
d2 = [d2, (acosd(a'*b/(norm(a)*norm(b))))];
end
hold on;plot(d2, 'r')
legend('Angles between linear weights vector and its discretization','Angles between two random ternary weights vector')
% d3 = [];
% for ii = 1: 1000
% a = rand(dim,1)+rand(dim,1).*-1;
% a = ceil(a.*10);
% r = 0 + 3.*randn(dim,1)+-3.*randn(dim,1);
% b = a + r; 
% d3 = [d3, real(acosd(a*b/(norm(a)*norm(b))))];
% end
% hold on;plot(d3, g)