%%%%%%%%%%%%%
% Code to train boolean weights classifier (Figure 6,7 and various supp. figures)
% "Invariant Odor Recognition with ON-OFF Neural Ensembles"
% Authors:Srinath Nizampatnam, Lijun Zhang, Rishabh Chandak, James Li, Barani Raman
% Washington University in St. Louis
% Code written by: Lijun Zhang
% Version current as of: December 10, 2021
% doi: 10.1073/pnas.2023340119
%%%%%%%%%%%%%

clear;close all;
filepath = '..\.\data\';
load([filepath,'PNs_hex']);
load([filepath,'PNs_iaa']);
for n = 1:length(hex_4s)
    PNtmp1(n,:,1:10)= hex_4s{n}';%dd2(:,261:470)';
    PNtmp1(n,:,11:20)= iaa_4s{n}';%dd_1(:,261:470)';
end

trials=20;
PNtmp2 = PNtmp1(:,161:360,1:trials); %baseline and 4s 

%% Building the dataset and ternary classifier
% slight performance difference may occur due to initialization
% randomization
% to test iaa classifier, change line 16 and 17 to
% PNtmp1(n,:,1:10)= iaa_4s{n}';
% PNtmp1(n,:,11:20)= hex_4s{n}';
% and change line 120 to
% dd3 =iaa_dry{n};
% To test classifier performance under humidity, 
% change the line 120 to
% dd3 =hex_humid{n};
X=[];    
for i=1:trials
    X=[X,PNtmp2(:,41:120,i)];%80

end
for i=1:trials
    X=[X,PNtmp2(:,1:40,i)];
end
for i=1:trials
    X=[X,PNtmp2(:,121:160,i)];
end
ns=9;
N=size(X,2);
Y=[ones(1,800),-1*ones(1,2400)];
data=X;
Ytotal=Y;
Dim=89;
len=2;
trainErr(1)=1;%length(find(sign(Wh'*X-tau)-Y))/N;
dataNorm=data;
trainErr(1)=1;%length(find(sign(Wh'*X-tau)-Y))/N;
lambda=1/2;%1/3 2/3
dim1=Dim;%600
dout=1;
number=1;%20
alpha=1*randn(dim1*dout,1);
b=zeros(dout,1);
C=[1,0];
rng(1,'philox')
randt=rand(dim1*dout,1);
beta1=0.9;
beta2=0.999;

m=0.001*randn(dim1*dout,1);
v=m.^2;
step=0.1;
epsilon=10^-8;
for ii=1:100

X=dataNorm;

for iter=1:10
    dGrad=zeros(dim1*dout,1);
for jj=1:number
    temp=rand(dim1*dout,1);
    Z=((alpha)+log(temp)-log(1-temp))/lambda;
    tw=logsig(Z);    
    tw=reshape(tw,[Dim,dout]);        
    NN_O=(tw'*X-repmat(b,[1,N]));
    ll=sum(log(logsig(Y.*NN_O)));
    lg=sum(log(lambda)-lambda*Z+alpha-2*log(1+exp(-lambda*Z+alpha)));% log approximate distribution
    lb=(ll-(lg));% log lowerbound
     grad1=(Y.*exp(-Y.*NN_O)./(1+exp(-Y.*NN_O)));
    dtw=X*grad1';
    gradient=[dtw(:)];

    gradB=gradient.*logsig(Z).*(1-logsig(Z))/lambda;%gradient arrives in output of neural network

    dGrad=dGrad+gradB;
end
    m=beta1*m+(1-beta1)*dGrad;
    mt=m/(1-beta1^ii);
    v=beta2*v+(1-beta2)*(dGrad.^2);
    vt=v/(1-beta2^ii);
    alpha=alpha+(step)*mt./(sqrt(vt)+epsilon);

end

    temp=rand(dim1*dout,1);
    Z=((alpha)+log(temp)-log(1-temp))/lambda;
    [~,idx]=max([logsig(Z),1-logsig(Z)],[],2);
    tw=C(idx)';
    tw=reshape(tw,[Dim,dout]);
    [b0, fX, i] = minimize(b,'loglik_single_2', 3, X,tw,Y);%100
    b=b0;
    NN_O=(tw'*X-repmat(b,[1,N]));
    pred=logsig(NN_O);
    true=(Y+1)/2;
    trainErr(ii)=sum(round(pred)~=true)/(N);% log lowerbound
    trainErr(ii)
end

sumnum=1;
for jj=1%:length(fg)
    count=0;
    for kk=1:1
        for n = 1:length(iaa_dry)
            dd3 =hex_dry{n};
            Seq_data(n,:,1:10) = dd3(:,:)';
        end



        Seq_resp = Seq_data;

        BN = Seq_resp;
       for ii=1:10
%             H=logsig(tw1'*BN(:,:,ii)-repmat(b(1:dim1),[1,1600]));
            NN_O=(tw'*BN(:,:,ii)-repmat(b,[1,1600]));
            pred=logsig(NN_O);
            Novel_classON(ii,:)=round(pred);
        end        
        %% plotting solitary
      
        %% plotting sequential
        subplot(2,1,1);
        rectangle('Position', [32,0,8,10], ...
            'FaceColor', [.7 .9 .7], 'EdgeColor',[.7 .9 .7], 'LineWidth', 0.1); hold on;
        rectangle('Position', [45,0,4,10], ...
            'FaceColor', [.7 .7 .9], 'EdgeColor',[.7 .7 .9], 'LineWidth', 0.1); hold on;
        rectangle('Position', [15,0,1,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        rectangle('Position', [16.5,0,1,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        rectangle('Position', [18,0,1,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7], 'LineWidth', 0.1); hold on;
        rectangle('Position', [20,0,3,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        rectangle('Position', [25,0,2,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        rectangle('Position', [34,0,1,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        rectangle('Position', [35.5,0,1,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        rectangle('Position', [37,0,1,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        rectangle('Position', [49.5,0,1,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        rectangle('Position', [51,0,1,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        rectangle('Position', [52.5,0,1,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        for tr = 1:10
            CR = find(Novel_classON(tr,:) == 1);
            CR = CR/20;
   
            for s=1:length(CR)
                line([CR(s),CR(s)],[10-tr,10-tr+1],'Color','r');
            end

        end         
%         axis([0 16 0 10]); 
        if kk<5
            set(gca,'xtick',[]);
        end
        if kk==5
            xlabel('Time (s)');
        end
        
        Novel_psthON = mean(Novel_classON,1);
        if jj==1
            classRed(kk+1,:) = Novel_psthON;
        end

        Novel_psthON = filtfilt(ones(1,3),3,Novel_psthON);


        axis([13 55.5 0 10]);    
        count = count+1;
        subplot(2,1,2);
        rectangle('Position', [32,0,8,10], ...
            'FaceColor', [.7 .9 .7], 'EdgeColor',[.7 .9 .7], 'LineWidth', 0.1); hold on;
        rectangle('Position', [45,0,4,10], ...
            'FaceColor', [.7 .7 .9], 'EdgeColor',[.7 .7 .9], 'LineWidth', 0.1); hold on;
        rectangle('Position', [15,0,1,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        rectangle('Position', [16.5,0,1,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        rectangle('Position', [18,0,1,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7], 'LineWidth', 0.1); hold on;
        rectangle('Position', [20,0,3,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        rectangle('Position', [25,0,2,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        rectangle('Position', [34,0,1,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        rectangle('Position', [35.5,0,1,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        rectangle('Position', [37,0,1,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        rectangle('Position', [49.5,0,1,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        rectangle('Position', [51,0,1,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        rectangle('Position', [52.5,0,1,10], ...
            'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
        dt = 0.05*sumnum;
        xn = dt:dt:80;
        plot(xn,Novel_psthON(1:length(xn)),'r');
%         plot(xn,Novel_psthOFF(1:length(xn)),'b');
        axis([13 55.5 0 1]);    
%         set(gcf,'Position',[599 850 876 188]);
    end
end

%%
% then backpropagate in neural network
[value,index]=sort(tw,'descend');
% load('idx2.mat')
temp=tw(index);
t2=[];
for i=1:length(tw)
    t2=[t2,temp(i)];
    t2=[t2,temp(i)];
    t2=[t2,temp(i)];
    t2=[t2,temp(i)];
    t2=[t2,2];
end
figure;imagesc([t2'])
% colormap([0,0,1;1,1,1;1,0,0;0.8,0.8,0.8])
colormap([1,1,1;1,0,0;0.8,0.8,0.8])

