%%%%%%%%%%%%%
% Code to train SVM and perform SVM classifier related analysis(Figure
% 5,6,7 and various supp. figures)
% "Invariant Odor Recognition with ON-OFF Neural Ensembles"
% Authors:Srinath Nizampatnam, Lijun Zhang, Rishabh Chandak, James Li, Barani Raman
% Washington University in St. Louis
% Code written by: Lijun Zhang
% Version current as of: December 10, 2021
% doi: 10.1073/pnas.2023340119
%%%%%%%%%%%%%
clear;close all;
filepath = '..\.\data\';
load([filepath,'PNs_hex']);
load([filepath,'PNs_iaa']);
load([filepath,'colormap.mat']);
cmap=x;
for n = 1:length(hex_4s)
    PNtmp1(n,:,1:10)= hex_4s{n}';
    PNtmp1(n,:,11:20)= iaa_4s{n}';

end
threshold1=0.4;
threshold2=-0.6;
trials=20;
PNtmp2 = PNtmp1(:,161:360,1:trials); %baseline and 4s 

%% Building the dataset and classifier
% To test iaa classifier, change line 18 and 19 to 
% PNtmp1(n,:,1:10)= iaa_4s{n}';
% PNtmp1(n,:,11:20)= hex_4s{n}';
% and change line 55 to
% dd3 =iaa_dry{n};
% To test classifier performance under humidity, 
% change the line 55 to
% dd3 =hex_humid{n};
X=[];    
for i=1:20
    X=[X,PNtmp2(:,41:120,i)];%80
end
for i=1:20
    X=[X,PNtmp2(:,1:40,i)];
end
for i=1:20
    X=[X,PNtmp2(:,121:160,i)];
end
ns=9;
N=size(X,2);
Y=[ones(1,800),-1*ones(1,2400)];%2400
mdl = fitcsvm(X',Y');
%% Odor prediction and generate the classification results
figure
sumnum=1;
count=0;
for n = 1:length(hex_dry)
    dd3 =hex_dry{n};
    Seq_data(n,:,1:10) = dd3(:,:)';
end
%       obtain the discretization  
discrete=zeros(89,1);
for i =1:89
    if mdl.Beta(i)>threshold1
        discrete(i)=1;
    else
        if mdl.Beta(i)<threshold2
            discrete(i)=-1;
        else
            discrete(i)=0;
        end
    end
end
BN = Seq_data;
for ii=1:10
    pred = predict(mdl,BN(:,:,ii)');
    Novel_classON(ii,:)=round((pred+1)/2);
%     Uncommented out the next two lines for discretization of SVM
%     classifier performance
%             pred=logsig(discrete'*BN(:,:,ii)+mdl.Bias);
%             Novel_classON(ii,:)=round(pred);%round((pred+1)/2);
end        
% plotting sequential prediction
subplot(2,1,1);
rectangle('Position', [32,0,8,10], ...
    'FaceColor', [.7 .9 .7], 'EdgeColor',[.7 .9 .7], 'LineWidth', 0.1); hold on;
rectangle('Position', [45,0,4,10], ...
    'FaceColor', [.7 .7 .9], 'EdgeColor',[.7 .7 .9], 'LineWidth', 0.1); hold on;
rectangle('Position', [15,0,1,10], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
rectangle('Position', [16.5,0,1,10], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
rectangle('Position', [18,0,1,10], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7], 'LineWidth', 0.1); hold on;
rectangle('Position', [20,0,3,10], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
rectangle('Position', [25,0,2,10], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
rectangle('Position', [34,0,1,10], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
rectangle('Position', [35.5,0,1,10], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
rectangle('Position', [37,0,1,10], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
rectangle('Position', [49.5,0,1,10], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
rectangle('Position', [51,0,1,10], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
rectangle('Position', [52.5,0,1,10], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;

for tr = 1:10
    CR = find(Novel_classON(tr,:) == 1);
    CR = CR/20;

    for s=1:length(CR)
        line([CR(s),CR(s)],[10-tr,10-tr+1],'Color','r');
    end

end         

xlabel('Time (s)');
Novel_psthON = mean(Novel_classON,1);
Novel_psthON = filtfilt(ones(1,3),3,Novel_psthON);
axis([13 55.5 0 10]); 
count = count+1;
subplot(2,1,2);
rectangle('Position', [32,0,8,1], ...
    'FaceColor', [.7 .9 .7], 'EdgeColor',[.7 .9 .7], 'LineWidth', 0.1); hold on;
rectangle('Position', [45,0,4,1], ...
    'FaceColor', [.7 .7 .9], 'EdgeColor',[.7 .7 .9], 'LineWidth', 0.1); hold on;
rectangle('Position', [15,0,1,1], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
rectangle('Position', [16.5,0,1,1], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
rectangle('Position', [18,0,1,1], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7], 'LineWidth', 0.1); hold on;
rectangle('Position', [20,0,3,1], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
rectangle('Position', [25,0,2,1], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
rectangle('Position', [34,0,1,1], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
rectangle('Position', [35.5,0,1,1], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
rectangle('Position', [37,0,1,1], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
rectangle('Position', [49.5,0,1,1], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
rectangle('Position', [51,0,1,1], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
rectangle('Position', [52.5,0,1,1], ...
    'FaceColor', [.9 .7 .7], 'EdgeColor',[.9 .7 .7 ], 'LineWidth', 0.1); hold on;
dt = 0.05*sumnum;
xn = dt:dt:80;
plot(xn,Novel_psthON(1:length(xn)),'r');
%         plot(xn,Novel_psthOFF(1:length(xn)),'b');
axis([13 55.5 0 1]);    
%         set(gcf,'Position',[599 850 876 188]);
% dex=[301:320;331:350;360:380;400:460;501:540;681:700;710:730;740:760;990:1010;1020:1040;1050:1070];
dex=[301,320;331,350;360,380;400,460;501,540;681,700;711,730;741,760;991,1010;1021,1040;1051,1070];
% mean(mean(BN(:,301:320,:),2),3)
TR=[];
for i = 1:11
    TR=[TR,mean(mean(BN(:,dex(i,1):dex(i,2),:),2),3)];
end


%% Plot the weights and compared to neuronal responsiveness
%find responsive and non-responsive neurons
[ExcB,InhB] =  examine_ExcitInhib(PNtmp1(:,1:280,1:trials),201,10);
one=zeros(89,1);
one(ExcB)=1;
[ExcB2,InhB2] =  examine_ExcitInhib(PNtmp1(:,[1:200,291:370],1:trials),201,10);
offe=zeros(89,1);
offe(ExcB2)=-1;
% plot the weights
% linear weights
tw=mdl.Beta;
[value,index]=sort(tw,'descend');
temp=value;
t2=[];
for i=1:length(temp)%discrete
    t2=[t2,temp(i)];
    t2=[t2,temp(i)];
    t2=[t2,temp(i)];
    t2=[t2,temp(i)];
    t2=[t2,2];%0
end
figure;imagesc([t2'],[-2 2])
title('linear svm weights')
colormap(cmap)%flip(cmap3,1))
colorbar
% discretization
temp=discrete(index);
t2=[];
for i=1:length(temp)%discrete
    t2=[t2,temp(i)];
    t2=[t2,temp(i)];
    t2=[t2,temp(i)];
    t2=[t2,temp(i)];
    t2=[t2,2];%0
end
figure;imagesc([t2'])
colormap([0,0,1;1,1,1;1,0,0;0.8,0.8,0.8])
title('discretized svm weights')

load([filepath,'weight_hex.mat'])
% [value,index]=sort(tw,'descend');

temp=tw(index);
t2=[];
for i=1:length(temp)%discrete
    t2=[t2,temp(i)];
    t2=[t2,temp(i)];
    t2=[t2,temp(i)];
    t2=[t2,temp(i)];
    t2=[t2,2];%0
end
figure;imagesc([t2'])
colormap([0,0,1;1,1,1;1,0,0;0.8,0.8,0.8])
title('ternary weights')

% plot the overlap between weights and neuron responsiveness
onper1=length(intersect(find(tw>=0),ExcB))/length(ExcB);
onper2=length(intersect(find(tw<0),ExcB))/length(ExcB);
offper1=length(intersect(find(tw>=0),ExcB2))/length(ExcB2);
offper2=length(intersect(find(tw<0),ExcB2))/length(ExcB2);
figure;hb=bar([onper1,onper2,offper1,offper2]);
temp=gcf;
pos=temp.Position;
set(gcf,'Position',[pos(1),pos(2),pos(3)*0.5,pos(4)*0.5])

%% 
peak_ON=max(mean(PNtmp1(:,201:280,1:10),3),[],2);
peak_OFF=max(mean(PNtmp1(:,291:370,1:10),3),[],2);
diff=peak_ON-peak_OFF;%
figure;plot(diff,mdl.Beta,'o');
% figure;plot(diff,discrete,'o');
axis square
mdl2 = LinearModel.fit(diff,mdl.Beta);
% mdl2 = LinearModel.fit(diff,discrete);
hold on
plot(-2:0.1:4,0.58631*[-2:0.1:4]-0.16899,'color','k');
xlabel('Difference between ON and OFF peak responses')
ylabel('SVM weights learned')

%% PSTH plots sorted based on linear weights learned
PSTH=mean(PNtmp1(:,161:400,1:10),3);
PSTH = filtfilt(ones(1,3),3,PSTH')';
PSTH=PSTH(:,41:200);
figure;hold on
cidx=34+[1:2:178];
cmap2=flip(cmap);
for i =1:89
plot(PSTH(index(i),:)-0.1*i,'linewidth',1,'color',cmap2(cidx(i),:))
end