function [ExcB,InhB] =  examine_ExcitInhib(Data,Onset,otrl)
% To generate
% Data : neurons x time x trials
% StringName : group variables
% Bst: baseline start point
% Bsp: baseline stop point

[Nnum,jump,Con] = size(Data);
Sdur= jump-Onset+1;
%------- choose Responsive cells --------------
Thr = 6.5; % Exct 6.5
Thr2 = 2; %inhi
Reb = ceil(otrl/2);% reliability crit
Cname = {'Dry'};%{'Back','Fore'}; %{'Back','Fore','Mixt'};
ExcInh = zeros(Nnum, length(Cname));
for ii = 1:Nnum,
    Data(ii,:,:) = filtfilt(ones(1,3),3, squeeze(Data(ii,:,:)) );
    for jj = 1:length(Cname)
        Base = mean(Data(ii,1:Onset-1,(jj-1)*otrl+1:jj*otrl),3);
        Odur = squeeze(Data(ii,Onset:end,(jj-1)*otrl+1:jj*otrl));
        %         Odur = filtfilt(ones(1,3),3,Odur);
        % Excitatory definition
        if max(mean(Odur,2))-mean(Base) > Thr*std(Base),
            Flg = 0;
            for kk = 1:otrl
                if max(Odur(:,kk))-mean(Base) > Thr*std(Base), Flg = Flg + 1; end
            end
            if Flg > Reb, ExcInh(ii,jj) = 1; end
            % inhibitory definition
        elseif max(mean(Odur,2))-mean(Base) < Thr2*std(Base)...
                && mean(mean(Odur)) < mean(Base)
            Flg = 0; Flg1 = 0;
            for kk = 1:otrl
                if mean(Odur(1:end,kk)) < mean(Base),  Flg = Flg + 1; end
                if mean(Odur(Sdur/2+1:end,kk)) < mean(Base), Flg1 = Flg1 + 1; end
            end
            if Flg>Reb , ExcInh(ii,jj) = -1; end
        end
    end
end

ExcB = find(ExcInh(:,1)==1);% ExcF = find(ExcInh(:,2)==1);
InhB = find(ExcInh(:,1)==-1);% InhF = find(ExcInh(:,2)==-1);

Excitatory =length(ExcB)/Nnum; %[length(ExcB);length(ExcF)]/Nnum;
Inhibitory = -length(InhB)/Nnum; %-[length(InhB);length(InhF)]/Nnum;
end